/*+
|          Sistemas Integrados TEKNISA               	|
|                  Core Vision                                            	|
|                                                 			|
|            Procedure: ETL_LIGACAOTEL            		|
|                                                 			|
|    Etl para cadastro de informaes sobre       		|
|   ligaes telefnicas visualizao no CVI.     		|
|                                                 			|
|       Preenche a tabela ETLLIGACAOTEL           	|
|                                                 			|
|       Criao:                                	 		|
|       23/10/2007 - Danilo dos Anjos Faria       		|
|                                                 			|            	              
|       Alterao:					|
|       19/12/2007 - Luiz Passos			|
|                                                 			|
|                                                 			|
+*/

create or replace
PROCEDURE ETL_LIGACAOTEL
                          (P_DTINI      IN DATE, 
                           P_DTFINA     IN DATE) 
IS 
   V_COUNTER         NUMBER  NOT NULL := 0; 
   V_DTFIM           DATE; 
   V_DTINI           DATE; 
   V_NRTELETARIFA    VARCHAR2(30) := NULL;
   V_AUXNRTEL        VARCHAR2(30) := NULL;   
   V_DSENTLIGTEL     VARCHAR2(60) := NULL;
   V_DSTIPLIGTEL     VARCHAR2(20) := NULL;
   V_IDTPETELBINA    VARCHAR2(03) NOT NULL := '0';
   V_CDENTTELBINA    VARCHAR2(50) NOT NULL := '0';     
   V_IDTIPTAREFA     TAREFA.IDTIPTAREFA%TYPE;
   V_DSSENTLIG        VARCHAR2(09) := NULL; 
   V_DSTPENTLIGTEL   VARCHAR2(50) := NULL;
   V_MES             VARCHAR2(02); 
   V_ANO             VARCHAR2(04);    
   /* Gravar os dados na tabela temporria TT_LIGTEL*/
   PROCEDURE GRAVA_LIGTEL(V_NMENTIDADE IN VARCHAR2 := NULL,
                          V_TPENTIDADE IN VARCHAR2 := NULL,
                          V_NRTELEFONE IN VARCHAR2 := NULL) IS
   BEGIN
      IF (V_NRTELEFONE IS NOT NULL) THEN
         INSERT INTO TT_LIGTEL 
                 (NMENTLIGTEL ,  NRTELLIGTEL , IDTPTELLIGTEL)
         VALUES  (V_NMENTIDADE,  V_NRTELEFONE, V_TPENTIDADE );
      END IF;
      V_COUNTER := V_COUNTER + 1;
      IF V_COUNTER >= 100 THEN
         COMMIT;
         V_COUNTER := 0;
      END IF;
   END;
BEGIN 
   DELETE FROM TT_LIGTEL;--> Limpa os dados atuais da tabela temporria para insero de dados atualizados
   V_MES  :=  TO_CHAR(P_DTINI,'MM'); 
   V_ANO  :=  TO_CHAR(P_DTINI,'YYYY');    
   DELETE FROM ETLLIGACAOTEL
   WHERE (ANETLLIGTEL > V_ANO)  
      OR (ANETLLIGTEL = V_ANO AND MEETLLIGTEL >= V_MES);  
   COMMIT;    
   V_DTINI := ADD_MONTHS(LAST_DAY(P_DTINI) + 1, -1);  -- PRIMEIRO DIA DO MS
   BEGIN
      FOR C_TT_LIGTEL IN 
        (
         SELECT PR.NMFANTPROS,
                EXTRACT_TEL(EP.NRTELRESIPRO) AS NRTELRESIPRO,
                EXTRACT_TEL(EP.NRTELEXPROS ) AS NRTELEXPROS,   
                EXTRACT_TEL(EP.NRTELEPROS1 ) AS NRTELEPROS1,   
                EXTRACT_TEL(EP.NRTELEPROS  ) AS NRTELEPROS,
                EXTRACT_TEL(EP.NRFAXPROS   ) AS NRFAXPROS,
                EXTRACT_TEL(EP.NRCELULARPRO) AS NRCELULARPRO
         FROM   ENDEPROSPECT EP, PROSPECT PR
         WHERE  PR.CDPROSPECT = EP.CDPROSPECT
        ) 
      LOOP
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTPROS, 'PRO', C_TT_LIGTEL.NRTELRESIPRO);
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTPROS, 'PRO', C_TT_LIGTEL.NRTELEXPROS );
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTPROS, 'PRO', C_TT_LIGTEL.NRTELEPROS1 );
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTPROS, 'PRO', C_TT_LIGTEL.NRTELEPROS  );
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTPROS, 'PRO', C_TT_LIGTEL.NRFAXPROS   );
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTPROS, 'PRO', C_TT_LIGTEL.NRCELULARPRO);         
      END LOOP;
   END;
   BEGIN
      FOR C_TT_LIGTEL IN 
        (
         SELECT CL.NMFANTCLIE,
                EXTRACT_TEL(EC.NRTELRESICLI) AS NRTELRESICLI,
                EXTRACT_TEL(EC.NRTELEXCLIE ) AS NRTELEXCLIE,
                EXTRACT_TEL(EC.NRTELECLIE1 ) AS NRTELECLIE1,
                EXTRACT_TEL(EC.NRTELECLIE  ) AS NRTELECLIE,
                EXTRACT_TEL(EC.NRFAXCLIE   ) AS NRFAXCLIE,
                EXTRACT_TEL(EC.NRCELULARCLI) AS NRCELULARCLI
         FROM   ENDECLIE EC, CLIENTE CL
         WHERE  EC.CDCLIENTE = CL.CDCLIENTE
        )
      LOOP
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTCLIE, 'CLI', C_TT_LIGTEL.NRTELRESICLI);
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTCLIE, 'CLI', C_TT_LIGTEL.NRTELEXCLIE );
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTCLIE, 'CLI', C_TT_LIGTEL.NRTELECLIE1 );
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTCLIE, 'CLI', C_TT_LIGTEL.NRTELECLIE  );
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTCLIE, 'CLI', C_TT_LIGTEL.NRFAXCLIE   );
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTCLIE, 'CLI', C_TT_LIGTEL.NRCELULARCLI);
      END LOOP;
   END;
   BEGIN
      FOR C_TT_LIGTEL IN 
        (   
         SELECT FO.NMFANTFORN,
                EXTRACT_TEL(EF.NRTELRESIFOR) AS NRTELRESIFOR,
                EXTRACT_TEL(EF.NRTELEXFORN ) AS NRTELEXFORN,
                EXTRACT_TEL(EF.NRTELEFORN1 ) AS NRTELEFORN1,
                EXTRACT_TEL(EF.NRTELEFORN  ) AS NRTELEFORN,
                EXTRACT_TEL(EF.NRFAXFORN   ) AS NRFAXFORN,
                EXTRACT_TEL(EF.NRCELULARFOR) AS NRCELULARFOR
         FROM   ENDEFORN EF, FORNECEDOR FO
         WHERE  EF.CDFORNECED = FO.CDFORNECED
        )
      LOOP
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTFORN, 'FOR', C_TT_LIGTEL.NRTELRESIFOR);
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTFORN, 'FOR', C_TT_LIGTEL.NRTELEXFORN );
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTFORN, 'FOR', C_TT_LIGTEL.NRTELEFORN1 );
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTFORN, 'FOR', C_TT_LIGTEL.NRTELEFORN  );
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTFORN, 'FOR', C_TT_LIGTEL.NRFAXFORN   );
         GRAVA_LIGTEL(C_TT_LIGTEL.NMFANTFORN, 'FOR', C_TT_LIGTEL.NRCELULARFOR);
      END LOOP;
   END;
   BEGIN
      FOR C_TT_LIGTEL IN 
        (   
         SELECT IT.NMINTECLIE||' ('||CL.NMFANTCLIE||')' AS ENTIDADE,
                EXTRACT_TEL(NRTELREINCLI ) AS NRTELREINCLI,
                EXTRACT_TEL(NRTEL2INCLIE ) AS NRTEL2INCLIE,
                EXTRACT_TEL(NRTEL1INCLIE ) AS NRTEL1INCLIE,
                EXTRACT_TEL(NRFAXINCLIE  ) AS NRFAXINCLIE,
                EXTRACT_TEL(NRCELULINCLI ) AS NRCELULINCLI
         FROM   INTECLIE IT, CLIENTE CL
         WHERE  IT.CDCLIENTE = CL.CDCLIENTE
        )
      LOOP
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INC', C_TT_LIGTEL.NRTELREINCLI);
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INC', C_TT_LIGTEL.NRTEL2INCLIE);
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INC', C_TT_LIGTEL.NRTEL1INCLIE);
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INC', C_TT_LIGTEL.NRFAXINCLIE );
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INC', C_TT_LIGTEL.NRCELULINCLI);
      END LOOP; 
   END;
   BEGIN
      FOR C_TT_LIGTEL IN 
        (   
         SELECT IT.NMINTEPROS||' ('||PR.NMFANTPROS||')' AS ENTIDADE,
                EXTRACT_TEL(NRTELREINPRO ) AS NRTELREINPRO,
                EXTRACT_TEL(NRTEL2INPROS ) AS NRTEL2INPROS,
                EXTRACT_TEL(NRTEL1INPROS ) AS NRTEL1INPROS,
                EXTRACT_TEL(NRFAXINPROS  ) AS NRFAXINPROS,
                EXTRACT_TEL(NRCELULINPRO ) AS NRCELULINPRO
         FROM   INTEPROSP IT, PROSPECT PR
         WHERE  IT.CDPROSPECT = PR.CDPROSPECT   
        )
      LOOP
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INP', C_TT_LIGTEL.NRTELREINPRO);
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INP', C_TT_LIGTEL.NRTEL2INPROS);
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INP', C_TT_LIGTEL.NRTEL1INPROS);
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INP', C_TT_LIGTEL.NRFAXINPROS );
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INP', C_TT_LIGTEL.NRCELULINPRO);
      END LOOP; 
   END;
   BEGIN
      FOR C_TT_LIGTEL IN 
        (      
         SELECT IT.NMINTERFORN||' ('||NMFANTFORN||')' AS ENTIDADE,
                EXTRACT_TEL(NRSEGTELINTE) AS NRSEGTELINTE,
                EXTRACT_TEL(NRTELREINFOR) AS NRTELREINFOR,
                EXTRACT_TEL(NRPRIMTELINT) AS NRPRIMTELINT,
                EXTRACT_TEL(NRFAXINTERFO) AS NRFAXINTERFO,
                EXTRACT_TEL(NRCELULINFOR) AS NRCELULINFOR
         FROM   INTEFORN IT, FORNECEDOR FO
         WHERE  IT.CDFORNECED = FO.CDFORNECED
        )
      LOOP
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INF', C_TT_LIGTEL.NRSEGTELINTE);
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INF', C_TT_LIGTEL.NRTELREINFOR);
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INF', C_TT_LIGTEL.NRPRIMTELINT);
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INF', C_TT_LIGTEL.NRFAXINTERFO);
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'INF', C_TT_LIGTEL.NRCELULINFOR);
      END LOOP;  
   END;
   BEGIN
      FOR C_TT_LIGTEL IN 
        (      
         SELECT LI.NMFANTLUSO||' ('||CL.NMFANTCLIE||')' AS ENTIDADE,
                EXTRACT_TEL(NRTELEXLUSO) AS NRTELEXLUSO,
                EXTRACT_TEL(NRTELELUSO ) AS NRTELELUSO,
                EXTRACT_TEL(NRFAXLUSO  ) AS NRFAXLUSO
         FROM   LICENCAUSO LI, CLIENTE CL
         WHERE  LI.CDCLIENTE = CL.CDCLIENTE
        )
      LOOP
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'LUS', C_TT_LIGTEL.NRTELEXLUSO);
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'LUS', C_TT_LIGTEL.NRTELELUSO);
         GRAVA_LIGTEL(C_TT_LIGTEL.ENTIDADE, 'LUS', C_TT_LIGTEL.NRFAXLUSO);
      END LOOP;  
   END;
   V_COUNTER := 0;
   COMMIT;   
   WHILE (V_DTINI  <=  P_DTFINA) LOOP     
      V_DTFIM      :=   LAST_DAY( V_DTINI); 
      V_MES        :=   TO_CHAR(V_DTFIM,'MM'); 
      V_ANO        :=   TO_CHAR(V_DTFIM,'YYYY'); 
      FOR C_ETL IN 
         (
         SELECT 
                 FL.CDFILIAL, FL.DTINICIALBI
           FROM  
                 FILIAL FL
           WHERE 
                 FL.IDFUNCAOFILI IS NULL     
             AND FL.DTINICIALBI  IS NOT NULL
         ) LOOP           
            IF ADD_MONTHS(LAST_DAY(C_ETL.DTINICIALBI) + 1, -1) <= V_DTINI THEN   
               FOR C_LIGTEL IN 
                   (
                    SELECT 
                             NRTELETARIFA, IDSENTTARIFA, NRRAMATARIFA,
                             SUM(VRLIGATARIFA) AS VRLIGATARIFA,
                             SUM(QTHRDURALIGA  * 3600) AS QTSEGDURALIGA,
                             COUNT(*) AS QTLIGTEL,     NMLOCATARIFA
                    FROM
                             TARIFADOR
                    WHERE     
                             CDFILIAL  =   C_ETL.CDFILIAL          
                             AND  TRUNC(DTTARIFADOR) BETWEEN TRUNC(V_DTINI) AND TRUNC(V_DTFIM)
                    GROUP BY
                             NRTELETARIFA,   IDSENTTARIFA,  
                             NRRAMATARIFA,   NMLOCATARIFA  
                  ) LOOP
                     V_DSTPENTLIGTEL := NULL;
                     V_DSENTLIGTEL   := NULL;
                     V_DSTIPLIGTEL   := NULL;
                      BEGIN
                          SELECT  IDTPETELBINA,   CDENTTELBINA   --> Buscar a entidade da ligao
                          INTO    V_IDTPETELBINA, V_CDENTTELBINA
                          FROM    TELEFONEBINA
                          WHERE   NRTELEBINA = C_LIGTEL.NRTELETARIFA;
                      EXCEPTION
                         WHEN OTHERS THEN
                            V_IDTPETELBINA := '0';
                            V_CDENTTELBINA := '0';
                      END;
                     IF V_CDENTTELBINA <> '0' THEN
                         BEGIN
                            V_DSTIPLIGTEL := 'Trabalho';
                            IF V_IDTPETELBINA = 'CLI' THEN 
                               V_DSTPENTLIGTEL := 'Cliente';
                               SELECT NMFANTCLIE
                               INTO   V_DSENTLIGTEL
                               FROM   CLIENTE
                               WHERE  CDCLIENTE = V_CDENTTELBINA
                                 AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'PRO' THEN
                                V_DSTPENTLIGTEL := 'Prospect';
                                SELECT NMFANTPROS
                                INTO   V_DSENTLIGTEL
                                FROM   PROSPECT
                                WHERE  CDPROSPECT = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'FOR' THEN
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMFANTFORN
                                INTO   V_DSENTLIGTEL
                                FROM   FORNECEDOR
                                WHERE  CDFORNECED = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'OPE' THEN
                                V_DSTPENTLIGTEL := 'Funcionrio';
                                V_DSTIPLIGTEL   := 'Particular';
                                SELECT NMOPERADOR
                                INTO   V_DSENTLIGTEL
                                FROM   OPERADOR
                                WHERE  CDOPERADOR = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'FUN' THEN
                                V_DSTPENTLIGTEL := 'Funcionrio';
                                SELECT NMFUNC
                                INTO   V_DSENTLIGTEL
                                FROM   FUNCIONARIO
                                WHERE  CDFUNC = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'FIL' THEN    -- Filial
                                V_DSTPENTLIGTEL := 'Funcionrio';
                                SELECT NMFILIAL
                                INTO   V_DSENTLIGTEL
                                FROM   FILIAL
                                WHERE  CDFILIAL = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'EMP' THEN   -- Empresa
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMEMPRESA
                                INTO   V_DSENTLIGTEL
                                FROM   EMPRESA
                                WHERE  CDEMPRESA = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'CON' THEN   -- Consumidor
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMCONSUMIDOR
                                INTO   V_DSENTLIGTEL
                                FROM   CONSUMIDOR
                                WHERE  CDCONSUMIDOR = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'VEN' THEN   -- Vendedor
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMFANVEN
                                INTO   V_DSENTLIGTEL
                                FROM   VENDEDOR
                                WHERE  CDVENDEDOR = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'TRA' THEN  -- Transportadora
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMFANTTRAN
                                INTO   V_DSENTLIGTEL
                                FROM   TRANSPORT
                                WHERE  NRINSJURTRAN = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'AGE' THEN  -- Agncia
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMAGENCIA
                                INTO   V_DSENTLIGTEL
                                FROM   AGENCIA
                                WHERE  CDAGENCIA = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'MED' THEN  -- Mdico
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMMEDICO
                                INTO   V_DSENTLIGTEL
                                FROM   MEDICO
                                WHERE  CDMEDICO = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'HOS' THEN  -- Hospital
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMHOSPITAL
                                INTO   V_DSENTLIGTEL
                                FROM   HOSPITAL
                                WHERE  CDHOSPITAL = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'RPA' THEN  -- Responsvel pelo Paciente
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMRESPPACI
                                INTO   V_DSENTLIGTEL
                                FROM   RESPPACI
                                WHERE  CDRESPPACI = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'PAC' THEN  -- Paciente
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMPACIENTE
                                INTO   V_DSENTLIGTEL
                                FROM   PACIENTE
                                WHERE  CDPACIENTE = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'CAN' THEN
                                V_DSTPENTLIGTEL := 'Candidato';
                                SELECT NMCANDI
                                INTO   V_DSENTLIGTEL
                                FROM   CANDIDATO
                                WHERE  CDCAND = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'COM' THEN  -- Comensal
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMCOMENSAL
                                INTO   V_DSENTLIGTEL
                                FROM   COMENSAL
                                WHERE  CDCOMENSAL = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'VIS' THEN  -- Visitante
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMVISITANTE
                                INTO   V_DSENTLIGTEL
                                FROM   VISITANTE
                                WHERE  NRVISITANTE = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'LUS' THEN -- Licena de Uso
                                V_DSTPENTLIGTEL := 'Cliente';
                                SELECT NMFANTLUSO||' ('||NMFANTCLIE||')' AS ENTIDADE
                                INTO   V_DSENTLIGTEL
                                FROM   LICENCAUSO LI, CLIENTE CL
                                WHERE  LI.CDCLIENTE = V_CDENTTELBINA
                                  AND  LI.CDCLIENTE = CL.CDCLIENTE
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'CNV' THEN -- Convnio
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMCONVENIO
                                INTO   V_DSENTLIGTEL
                                FROM   CONVENIO
                                WHERE  CDCONVENIO = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'LAB' THEN -- Laboratrio
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMLABORAT
                                INTO   V_DSENTLIGTEL
                                FROM   LABORATOR
                                WHERE  CDLABORAT = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'ATH' THEN -- Atendimento Hospitalar
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT P.NMPACIENTE
                                INTO   V_DSENTLIGTEL
                                FROM   PACIENTE P, ATENHOSP A
                                WHERE  P.CDPACIENTE  =   A.CDPACIENTE 
                                  AND  A.NRATENHOSP = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'INE' THEN -- Inscrio Estadual
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMREPRINSEST
                                INTO   V_DSENTLIGTEL
                                FROM   INSCRESTAD
                                WHERE  NRINSJURIEST = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'INT' THEN  -- Interlocutor
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMINTERLOCUT
                                INTO   V_DSENTLIGTEL
                                FROM   INTERLOCUTOR
                                WHERE  CDINTERLOCUT = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'INC' THEN -- Interlocutor do Cliente
                                V_DSTPENTLIGTEL := 'Cliente'; 
                                SELECT NMINTECLIE||' ('||NMFANTCLIE||')' AS ENTIDADE
                                INTO   V_DSENTLIGTEL
                                FROM   INTECLIE IT, CLIENTE CL
                                WHERE  IT.CDCLIENTE||IT.CDINTECLIE = V_CDENTTELBINA
                                  AND  IT.CDCLIENTE = CL.CDCLIENTE
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'INF' THEN -- Interlocutor do Fornecedor
                                V_DSTPENTLIGTEL := 'Fornecedor';
                                SELECT NMINTERFORN||' ('||NMFANTFORN||')' AS ENTIDADE
                                INTO   V_DSENTLIGTEL
                                FROM   INTEFORN IT, FORNECEDOR FO
                                WHERE  IT.CDFORNECED||IT.CDINTERLOC = V_CDENTTELBINA
                                  AND  FO.CDFORNECED = IT.CDFORNECED
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'INP' THEN -- Interlocutor do Prospect
                                V_DSTPENTLIGTEL := 'Prospect';
                                SELECT IT.NMINTEPROS||' ('||PR.NMFANTPROS||')' AS ENTIDADE
                                INTO   V_DSENTLIGTEL
                                FROM   INTEPROSP IT, PROSPECT PR
                                WHERE  IT.CDPROSPECT||IT.CDINTEPROS = V_CDENTTELBINA
                                  AND  PR.CDPROSPECT = IT.CDPROSPECT
                                  AND  ROWNUM = 1;
                             ELSIF V_IDTPETELBINA = 'TAR' THEN
                                SELECT IDTIPTAREFA
                                INTO   V_IDTIPTAREFA
                                FROM   TAREFA
                                WHERE  NRTAREFA = V_CDENTTELBINA
                                  AND  ROWNUM = 1;
                                IF V_IDTIPTAREFA = 'C' THEN
                                   SELECT C.NMFANTCLIE
                                   INTO   V_DSENTLIGTEL
                                   FROM   CLIENTE C, TAREFA T
                                   WHERE  C.CDCLIENTE = T.CDCLIENTE
                                     AND  T.NRTAREFA  = V_CDENTTELBINA
                                     AND  ROWNUM = 1;                                     
                                  V_DSTPENTLIGTEL := 'Cliente';
                                ELSIF V_IDTIPTAREFA = 'P' THEN
                                   SELECT P.NMFANTPROS
                                   INTO   V_DSENTLIGTEL
                                   FROM   PROSPECT P, TAREFA T
                                   WHERE  P.CDPROSPECT = T.CDPROSPECT
                                     AND  T.NRTAREFA  = V_CDENTTELBINA
                                     AND  ROWNUM = 1;
                                   V_DSTPENTLIGTEL := 'Prospect';
                                ELSIF V_IDTIPTAREFA = 'F' THEN          
                                   SELECT F.NMFANTFORN
                                   INTO   V_DSENTLIGTEL
                                   FROM   FORNECEDOR F, TAREFA T
                                   WHERE  F.CDFORNECED = T.CDFORNECED
                                     AND  T.NRTAREFA  = V_CDENTTELBINA
                                     AND  ROWNUM = 1;
                                   V_DSTPENTLIGTEL := 'Fornecedor';
                                END IF;                                              
                             ELSE
                                V_DSTIPLIGTEL := NULL;
                             END IF;
                         EXCEPTION
                             WHEN OTHERS THEN
                                 V_DSENTLIGTEL   := NULL;
                                 V_DSTPENTLIGTEL := NULL;
                         END;
                     END IF;
                     IF V_DSENTLIGTEL IS NULL THEN --> Se no achar a entidade, tenta novamente nas tabelas prprias
                        BEGIN
                           V_DSTIPLIGTEL   := 'Trabalho';
                           SELECT NMENTLIGTEL,   IDTPTELLIGTEL
                           INTO   V_DSENTLIGTEL, V_DSTPENTLIGTEL
                           FROM   TT_LIGTEL
                           WHERE  ROWNUM = 1
                             AND  NRTELLIGTEL =  C_LIGTEL.NRTELETARIFA;
                           V_DSTPENTLIGTEL := 
                              CASE  V_DSTPENTLIGTEL
                                 WHEN 'CLI' THEN 'Cliente'
                                 WHEN 'PRO' THEN 'Prospect'
                                 WHEN 'FOR' THEN 'Fornecedor'
                                 WHEN 'INC' THEN 'Cliente'
                                 WHEN 'INP' THEN 'Prospect'
                                 WHEN 'INF' THEN 'Fornecedor'
                                 WHEN 'LUS' THEN 'Cliente'
                              END;
                        EXCEPTION
                           WHEN OTHERS THEN                          
                           BEGIN
                              SELECT NMOPERADOR
                              INTO   V_DSENTLIGTEL
                              FROM   OPERADOR
                              WHERE  ROWNUM = 1
                                AND (EXTRACT_TEL(NRCELULAROPER) = C_LIGTEL.NRTELETARIFA
                                OR   EXTRACT_TEL(NRTELEOPER   ) = C_LIGTEL.NRTELETARIFA);
                              V_DSTPENTLIGTEL := 'Operador';
                              V_DSTIPLIGTEL   := 'Particular';
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 SELECT NMCANDI
                                 INTO   V_DSENTLIGTEL
                                 FROM   CANDIDATO
                                 WHERE  ROWNUM = 1
                                   AND (EXTRACT_TEL(NRFONE2CAND)   = C_LIGTEL.NRTELETARIFA
                                    OR   EXTRACT_TEL(NRFONECANDI)   = C_LIGTEL.NRTELETARIFA
                                    OR   EXTRACT_TEL(NRCELULARCAND) = C_LIGTEL.NRTELETARIFA);
                                 V_DSTPENTLIGTEL := 'Candidato';
                              EXCEPTION
                                 WHEN OTHERS THEN
                                 BEGIN
                                    SELECT NMAGENCIA 
                                    INTO   V_DSENTLIGTEL
                                    FROM   AGENCIA
                                    WHERE  ROWNUM = 1
                                      AND (EXTRACT_TEL(NRFONEAGEN)  =  C_LIGTEL.NRTELETARIFA
                                       OR  EXTRACT_TEL(NRFAXAGEN )  =  C_LIGTEL.NRTELETARIFA);
                                    V_DSTPENTLIGTEL := 'Fornecedor'; 
                                 EXCEPTION
                                    WHEN OTHERS THEN
                                       V_DSTPENTLIGTEL := NULL;
                                       V_DSTIPLIGTEL   := NULL;
                                 END;
                              END;
                            END;
                        END;
                     END IF;
                    V_NRTELETARIFA := C_LIGTEL.NRTELETARIFA;
                    IF SUBSTR(V_NRTELETARIFA, 1, 4) = '0800' THEN       --> Coloca a mscara 0800-99999999 em telefones 0800
                       V_NRTELETARIFA := SUBSTR(V_NRTELETARIFA, 1, 4)||'-'||SUBSTR(V_NRTELETARIFA, 5, 15);
                    ELSIF LENGTH(EXTRACT_TEL(V_NRTELETARIFA)) = 10 THEN --> Coloca a mscara (99)9999-9999 em nmeros de telefones regulares
                          V_NRTELETARIFA := '('||SUBSTR(V_NRTELETARIFA, 1, 2)||')'||SUBSTR(V_NRTELETARIFA, 3, 4)||'-'||SUBSTR(V_NRTELETARIFA, 7, 4);
                    END IF;
                    IF C_LIGTEL.IDSENTTARIFA = 'O' THEN 
                       V_DSSENTLIG := 'ORIGINADA';
                    ELSIF C_LIGTEL.IDSENTTARIFA = 'R' THEN
                       V_DSSENTLIG := 'RECEBIDA';
                    END IF;
                    --<-------INSERO DE DADOS DAS LIGAES------->--
                    INSERT INTO ETLLIGACAOTEL
                       ( 
                       CDFILIAL,                  NRTELLIGTEL, 
                       DSTIPLIGTEL,               NRRAMALLIGTEL,
                       DSTPENTLIGTEL,             ANETLLIGTEL,
                       MEETLLIGTEL,               VRLIGTEL,                       
                       NMENTLIGTEL,               QTLIGTEL,
                       NMLOCALLIGTEL,             DSSENTLIGTEL,
                       VRDURALIGTEL
                       ) 
                    VALUES 
                       ( 
                       C_ETL.CDFILIAL,            V_NRTELETARIFA,
                       V_DSTIPLIGTEL,             C_LIGTEL.NRRAMATARIFA,
                       V_DSTPENTLIGTEL,           V_ANO,      
                       V_MES,                     C_LIGTEL.VRLIGATARIFA,                
                       V_DSENTLIGTEL,             C_LIGTEL.QTLIGTEL,
                       C_LIGTEL.NMLOCATARIFA,     V_DSSENTLIG,
                       C_LIGTEL.QTSEGDURALIGA
                      ); 
                    V_COUNTER:= V_COUNTER+1; 
                    IF V_COUNTER >= 100 THEN 
                       COMMIT; 
                       V_COUNTER := 0; 
                    END IF;
                END LOOP;         -- fim do loop LIGTEL                 
             END IF;              -- Final da comparao com data de BI                            
         END LOOP;                 -- fim do loop por Filial
      COMMIT;           
      V_DTINI := ADD_MONTHS(V_DTINI,1); 
   END LOOP;                      -- loop por ms da etl
   COMMIT;         
   DELETE FROM TT_LIGTEL;      
   COMMIT;
END; 
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_LIGACAOTEL','5.01.002'); END;
/
